package flash
{
	import flash.utils.Dictionary;
    public dynamic class Main extends flash.display.MovieClip
    {
	const modname:String = "dialogpatchV3";
	
	var main;
	var g;
	public var persist:int = 1;
	public var cascadepriorities:int = 0;
	public var modSettingsLoader;
	
	var Him:Class;
	var DialogueLine:Class;
	var DialogueState:Class;
	//var saiddic:Dictionary = new Dictionary();

	
	var namearray:Dictionary = new Dictionary();
	
	public function initl(l){
		//CODE HERE!
		main = l;
		g = l.g;
		
		modSettingsLoader = main.eDOM.getDefinition("Modules.modSettingsLoader") as Class;			//finds the modsettingsloader class from the loader
	
		var mySettingsLoader = new modSettingsLoader(modname+"settings",onSettingsSucceed);	//creates a new settingsloader specifying the file to load and the funtion to run
		mySettingsLoader.addEventListener("settingsNotFound",onSettingsFail);
	}
	
	function onSettingsSucceed(e)			
	{
		var errorCounter:int = 0;
		var dict:Dictionary = e.settings;
		
		for (var key:Object in dict)
		{
			var val:Object = dict[key];
			if ( this.hasOwnProperty( key ) )			//checks if variable exists
			{
				this[key] = Number(val);    								//replaces all switch statement variable assignments
				//main.updateStatusCol(key + " = "+ val,"#00ff00");   //replaces all switch statement updatestatus notifications, comment line to hide
				//main.monitorDebug(key+": ",this,key);
			}
			else
			{
				if(key == "")
				{
					//main.updateStatusCol("blank line found in settings","#FF0000");
				}
				else
				{
					main.updateStatusCol("invalid setting: "+key,"#FF0000");	//displays if there is a setting in the settings file that does not match any variables
					errorCounter++;
				}
			}
		}
		finishinit();
	}
	
	function onSettingsFail(e)			
		{
			main.updateStatusCol(e.msg,"#FF0000");		//displays error message
			finishinit();
		}
	
	function finishinit()
	{
		var lProxy = main.lDOM.getDefinition("Modules.lProxy");
		DialogueLine = main.eDOM.getDefinition("obj.dialogue.DialogueLine") as Class;
		DialogueState = main.eDOM.getDefinition("obj.dialogue.DialogueState") as Class;
		Him = main.eDOM.getDefinition("obj.Him") as Class;
		
		var canPlayProx:Object = lProxy.createProxy(g.dialogueControl.advancedController, "canPlay");
		canPlayProx.addPre(canPlay, persist==1);
		canPlayProx.hooked = false;
		
		var sayranprox:Object = lProxy.createProxy(g.dialogueControl, "sayRandomPhrase");
		sayranprox.addPre(sayRandomPhrase, persist==1);
		sayranprox.hooked = false;
		
		if(cascadepriorities == 1)
		{
		var ddd:Object = lProxy.createProxy(g.dialogueControl, "checkForSpeechStart");
		ddd.addPost(checkForSpeechStart, persist==1);
		}
		
		//debug
		//var trig:Object = lProxy.createProxy(g.dialogueControl, "triggerState");
		//trig.addPre(triggerState, persist==1);
		
		
		
		main.updateStatusCol("loaded "+modname,"#00ff00");
		main.unloadMod();
	}
	
	public function triggerState(param1:String) : void
	{
		//main.updateStatus("trig "+param1);
	}
	
	function checkForSpeechStart()
	{
		if(g.dialogueControl.nextLineTimer == 0 ) poparray();
	}
	
	function poparray()
	{
		for(var i in namearray)
		{
			//g.dialogueControl.states[i]._noBuildDelay = 0;
			g.dialogueControl.states[i].buildState(namearray[i]);
			//main.updateStatus("popped "+i);
		}
		namearray = new Dictionary();
	
	}
	
	
	public function sayRandomPhrase(param1:String, param2:Boolean = false) : void
        {
			
			var _loc_5:* = null;
            var _loc_6:* = 0;
            var _loc_7:* = null;
            var _loc_3:* = g.dialogueControl.library.getPhrases(param1).slice();
			//debug
			//main.updateStatus("phrase size:"+_loc_3.length);
            var _loc_4:* = new Array();
            for each (_loc_5 in _loc_3)
            {
                if (mycanPlay(_loc_5))	//don't use object's canplay, use my custom one (which also calls my custom controller canplay)
                {
					_loc_4.push(_loc_5);
                }
            }
			//main.updateStatus("dialog:"+g.dialogue);
            if (g.dialogue && _loc_4.length > 0)
            {
				//main.updateStatus("found > 0");
                if (!g.dialogueControl.states[param1])
                {
                    g.dialogueControl.states[param1] = new DialogueState(0, 0);
                }
                g.dialogueControl.states[param1].clearBuild();
                g.dialogueControl.states[param1].delayBuild();
                _loc_6 = g.dialogueControl.states[param1].randomPhrase(_loc_4);
                var savedline = _loc_4[_loc_6];
				//main.updateStatus("saved line");
				//wassaved = param2;
                if (savedline)
				{
					//main.updateStatus("playing "+param1);
					if (param1 == "first_throat" && savedline.style == DialogueLine.SPEAKING_STYLE)
					{
						g.dialogueControl.firstThroatSpoken = true;
					}
					if (param2)
					{
						g.dialogueControl.reduceStates();
					}
					g.dialogueControl.startSpeakingPhrase(savedline);
					g.dialogueControl.sayingState = param1;
					if(cascadepriorities == 1) poparray();
					g.dialogueControl.nextLineTimer = 0;
					//saiddic = new Dictionary();
				}
            }
            else
            {
                
					if(param1 == "queued") 
					{
						g.dialogueControl.nextLineTimer = 0;
						return;
					}
					
					var had:Boolean = namearray[param1] != null;
					if (cascadepriorities == 1 && g.dialogueControl.states[param1])
					{
					//main.updateStatus("pushed "+param1);
					namearray[param1] = Math.max(0,g.dialogueControl.states[param1].build - 20);
					//if(had) namearray[param1] += Math.max(0,g.dialogueControl.states[param1].build - 20);
					//else    namearray[param1] = Math.max(0,g.dialogueControl.states[param1].build - 20);
					g.dialogueControl.states[param1].clearBuild();
					//g.dialogueControl.states[param1].delayBuild();
					}
					g.dialogueControl.nextLineTimer = had ? 0 : 19;
				
            }
            return;
        }// end function
	
	
		public function mycanPlay(line) : Boolean
        {
            if (g.her.passedOut && line._style == DialogueLine.THOUGHT_STYLE)
            {
                return false;
            }
            if ((!line._style || line._style == DialogueLine.SPEAKING_STYLE) && !g.her.canSpeak())
            {
                return false;
            }
            if (line._mood && g.her.mood != line._mood)
            {
                return false;
            }
            if (line._held)
            {
                if (line._held == "true" && Him.armPositions[g.him.currentArmPosition] != "Holding")
                {
                    return false;
                }
                if (line._held == "false" && Him.armPositions[g.him.currentArmPosition] != "Free")
                {
                    return false;
                }
            }
			if (g.dialogueControl.advancedController && !canPlay(line))
            {
                return false;
            }
            return true;
        }// end function
	
		public function canPlay(param1) : Boolean		//takes a dialog line, not string
        {
            //main.updateStatus("ran canplay");
			var _loc_2:* = null;
            var _loc_3:* = null;
            var _loc_4:* = null;
            var _loc_5:* = false;
            var _loc_6:* = "a";
            var _loc_7:* = null;
            var _loc_8:* = false;
            if (param1.settings["check"])
            {
				//debug
				//main.updateStatus("check ran");
                g.dialogueControl.advancedController.outputLog("Running checks for line: \"" + param1.phrase + "\"");
                _loc_2 = param1.settings["check"];
                for (_loc_3 in _loc_2)
                {
                    
                    _loc_4 = _loc_2[_loc_3];
                    _loc_5 = _loc_4 is Number;
                    _loc_6 = Number(_loc_4.toString().replace(/[\>\<\=\!]?[\>\<\=\!]?/g, ""));
					/*main.updateStatus("loc4:"+_loc_4);
					main.updateStatus("loc5:"+_loc_5);
					main.updateStatus("loc6:"+_loc_6);
					main.updateStatus("loc6rep:"+_loc_4.toString().replace(/[\>\<\=\!]?[\>\<\=\!]?/g, ""));*/
					
                    if (!_loc_5 && _loc_4 is String)
                    {
                        _loc_5 = !isNaN(_loc_6);
                    }
                    _loc_7 = g.dialogueControl.advancedController._dialogueDataStore.hasOwnProperty(_loc_3) ? (g.dialogueControl.advancedController._dialogueDataStore[_loc_3]) : (_loc_5 ? (0) : (false));
                    if (_loc_7 is Number && _loc_4 is String && _loc_5)
                    {
                        _loc_8 = true;
                        if (_loc_4.charAt(0) == ">")
                        {
                            if (_loc_4.charAt(1) == "=")
                            {
                                _loc_8 = _loc_7 >= _loc_6;
                            }
                            else
                            {
                                _loc_8 = _loc_7 > _loc_6;
                            }
                        }
                        else if (_loc_4.charAt(0) == "<")
                        {
                            if (_loc_4.charAt(1) == "=")
                            {
                                _loc_8 = _loc_7 <= _loc_6;
                            }
                            else
                            {
                                _loc_8 = _loc_7 < _loc_6;
                            }
                        }
                        else if (_loc_4.charAt(0) == "!" && _loc_4.charAt(1) == "=")
                        {
                            _loc_8 = _loc_7 != _loc_6;
                        }
						else
                        {
                            _loc_8 = _loc_7 == _loc_6;
                        }
                        if (!_loc_8)
                        {
                            g.dialogueControl.advancedController.outputLog("   Line will not play: \"" + _loc_3 + "\" needs to be " + _loc_4 + " but is currently set to " + g.dialogueControl.advancedController._dialogueDataStore[_loc_3]);
                            return false;
                        }
                    }
                    if (_loc_7 is Boolean && (_loc_4 == "true" || _loc_4 == "false"))
                    {
                        _loc_4 = _loc_4 == "true";
                    }
                    if (!(_loc_5 && _loc_4 is String) && _loc_7 != _loc_4)
                    {
                        g.dialogueControl.advancedController.outputLog("   Line will not play: \"" + _loc_3 + "\" needs to be " + _loc_4 + " but is currently set to " + g.dialogueControl.advancedController._dialogueDataStore[_loc_3]);
                        return false;
                    }
                }
                g.dialogueControl.advancedController.outputLog("   Okay.");
            }
            return true;
        }// end function
}
}